Billboard (线段树 单点更新)

来源:互联网 发布:微信开源mars源码分析 编辑:程序博客网 时间:2024/05/22 17:07

Billboard

Time Limit: 20000/8000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 16 Accepted Submission(s): 13 
Problem Description
At the entrance to the university, there is a huge rectangular billboard of size h*w (h is its height and w is its width). The board is the place where all possible announcements are posted: nearest programming competitions, changes in the dining room menu, and other important information.

On September 1, the billboard was empty. One by one, the announcements started being put on the billboard.

Each announcement is a stripe of paper of unit height. More specifically, the i-th announcement is a rectangle of size 1 * wi.

When someone puts a new announcement on the billboard, she would always choose the topmost possible position for the announcement. Among all possible topmost positions she would always choose the leftmost one.

If there is no valid location for a new announcement, it is not put on the billboard (that's why some programming contests have no participants from this university).

Given the sizes of the billboard and the announcements, your task is to find the numbers of rows in which the announcements are placed.
 
Input
There are multiple cases (no more than 40 cases).

The first line of the input file contains three integer numbers, h, w, and n (1 <= h,w <= 10^9; 1 <= n <= 200,000) - the dimensions of the billboard and the number of announcements.

Each of the next n lines contains an integer number wi (1 <= wi <= 10^9) - the width of i-th announcement.
 
Output
For each announcement (in the order they are given in the input file) output one number - the number of the row in which this announcement is placed. Rows are numbered from 1 to h, starting with the top row. If an announcement can't be put on the billboard, output "-1" for this announcement.
 
Sample Input
3 5 524333
 
Sample Output
1213-1
 
Author
hhanger@zju
 
Source
HDOJ 2009 Summer Exercise(5)

题意

 有一个w*h的版,然后让你贴海报,海报贴的方法是,优先贴最高的,然后再贴最左边的

题解:

线段树单点更新

主要问题就是建树的时候,需要稍微注意一下,因为只有200000个海报,所以只要建200000这么大的树就好了


 根据线段树的性质  
1--------------5
1------3 4----5
1---2 3  4  5
1 2
 
从左子树递归查询就可以了 ,结点保存范围内剩下的最大值。
#include <iostream>#include <string.h>#include <stdio.h>#include <vector>#include <cmath>#include <array>using namespace std;const int maxn = 200005;int tree[maxn << 2];int h, w, n;void create(int node, int left ,int right) {    tree[node] = w;    if (left == right) {        return;    }    int mid = (left + right) >> 1;    create(node << 1, left, mid);    create(node << 1 | 1, mid + 1, right);}int update(int node, int left, int right, int val) {    if (left == right) {        tree[node] -= val;        return left;    }    int mid = (left + right) >> 1;        int ans;        if (tree[node << 1] >= val)        ans = update(node << 1, left, mid, val);    else        ans = update(node << 1 | 1, mid + 1, right, val);        tree[node] = max(tree[node << 1], tree[node << 1 | 1]);        return ans;}int main() {        //freopen("in.txt", "r", stdin);    std::ios::sync_with_stdio(false);    std::cin.tie(0);    while (cin >> h >> w >> n) {        h = min(h, n);        create(1, 1, h);        for (int i = 0; i < n; ++i) {            int val;            cin >> val;            if (val > tree[1])                cout << -1 << endl;            else                cout << update(1, 1, h, val) << endl;        }    }}


原创粉丝点击